<?php
/**
 * User: Gergő
 * Date: 2020.04.17.
 * Time: 10:52
 * Project: waffel
 * Company: GreenTech
 */

namespace GT;

use GuzzleHttp\Client;

class Api
{
    protected $secret = 'Tth6FljWlgHfEKTvqnBKEHmCXLBi9ZgbdkvxtHAmajqrXnLtLW';
    protected $apikey = '9Q8A5gtZ212343bHo3I6f4eqy8MF77D78SI55M83q093Blt9de';
    protected $url = "https://leaderboard.esportuniversum.hu/";

    CONST HASH_FIELD = 'X-Hash';
    CONST NONCE_FIELD = 'X-Nonce';
    CONST CREATED_FIELD = 'X-Created';

    protected $eventId = 3;
    protected $gameId = 8;
    protected $nickname = null;
    protected $points = null;
    protected $phone = null;
    protected $email = null;

    /**
     * @return null
     */
    public function getNickname()
    {
        return $this->nickname;
    }

    /**
     * @param null $nickname
     */
    public function setNickname($nickname)
    {
        $this->nickname = $nickname;
    }

    /**
     * @return null
     */
    public function getPoints()
    {
        return $this->points;
    }

    /**
     * @param null $points
     */
    public function setPoints($points)
    {
        $this->points = $points;
    }

    /**
     * @return null
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * @param null $phone
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;
    }

    /**
     * @return null
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * @param null $email
     */
    public function setEmail($email)
    {
        $this->email = $email;
    }

    /**
     * @return null
     */
    public function getEvent()
    {
        return $this->eventId;
    }

    /**
     * @param null $eventId
     */
    public function setEvent($eventId)
    {
        $this->eventId = $eventId;
    }

    /**
     * @return null
     */
    public function getGame()
    {
        return $this->eventId;
    }

    /**
     * @param null $gameId
     */
    public function setGame($gameId)
    {
        $this->gameId = $gameId;
    }

    protected function hash($nonce, $created)
    {
        return base64_encode(sha1($nonce . $created . base64_encode(md5( $this->apikey) . $this->secret)));
    }

    public function send()
    {
        $client = new Client([
            'base_uri' => $this->url,
        ]);

        $time = time();
        $nonce = $this->getNonce();

        $headers = [
            self::CREATED_FIELD => $time,
            self::NONCE_FIELD => $nonce,
            self::HASH_FIELD => $this->hash($nonce,$time),
        ];

        $data = [
            'event_id' => $this->eventId,
            'game_id' => $this->gameId,
            'nickname' => $this->nickname,
            'points' => $this->points,
            'email' => $this->email,
            'phone' => $this->phone,
        ];

        $response = $client->request('POST', '/api/setScore', [
            'headers' => $headers,
            'form_params' => $data,
        ]);

        return $response->getBody()->getContents();
    }

    protected function getNonce($length = 10)
    {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }
}
